import '../util/compatibility';
import Options from '../types/options';
import { Message } from '../types/store';
import EmbedAPI from './embedAPI';
declare class Crate extends EmbedAPI {
    options: Options & {
        get: () => Options;
        set: (value: Options) => Options;
    };
    /**
     * Instantiate a new Crate instant
     * @param userOptions The options to use
     */
    constructor(userOptions: Options);
    /**
     * Force updates the React component
     */
    private forceUpdate;
    /**
     * Adds the event listeners for the embed-api transport
     */
    private addEventListeners;
    /*********   Public Methods   *********/
    /**
     * Updates the options by merging a new options object
     * @param options The new options object
     */
    setOptions(options: Options): Options & {
        get: () => Options;
        set: (value: Options) => Options;
    };
    /**
     * Toggles the widget open / closed
     */
    toggle(open?: boolean): void;
    /**
     * Notifies a message to the user
     */
    notify(content: string | (Message & {
        timeout?: string | false;
        id?: string;
        onClick?: () => void;
    })): {
        hide: () => import("redux-actions").Action<{
            id: string;
            decrement?: boolean;
        }>;
    };
    navigate(channelId: string): void;
    /**
     * Un-hides the crate button
     */
    show(): void;
    /**
     * Hides the crate button
     */
    hide(): void;
}
export default Crate;
