"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const __1 = require("..");
const elements_1 = require("./elements");
class Embed extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            deferred: true
        };
    }
    componentWillReceiveProps(nextProps) {
        if (nextProps.interactive && nextProps.open && this.state.deferred) {
            // User toggled open embed
            this.setState({ deferred: false });
        }
    }
    componentDidMount() {
        const { interactive } = this.props;
        // Allow 5 seconds for the target page to load,
        // before attempting to load the embed
        if (interactive) {
            setTimeout(() => this.setState({ deferred: false }), 5000);
        }
    }
    render() {
        const { options, open } = this.props;
        const { deferred } = this.state;
        return (React.createElement(elements_1.Root, { className: "embed" },
            React.createElement(__1.APIContext.Consumer, null, onAPI => (React.createElement(elements_1.IFrame, Object.assign({}, options, { options: {
                    preset: 'crate'
                }, defer: deferred, onAPI: onAPI, className: "react-embed", focusable: open }))))));
    }
}
exports.default = react_redux_1.connect(({ interactive, options, open }) => ({
    options: {
        server: options.server,
        channel: options.channel,
        shard: options.shard,
        thread: options.thread,
        username: options.username,
        avatar: options.avatar,
        token: options.token,
        notifications: options.allChannelNotifications,
        notificationTimeout: options.embedNotificationTimeout,
        accessibility: options.accessibility,
        settingsGroup: options.settingsGroup
    },
    interactive,
    open
}))(Embed);
//# sourceMappingURL=index.js.map