"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.APIContext = void 0;
const emotion_1 = require("emotion");
const React = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const react_shadow_1 = __importDefault(require("react-shadow"));
const embedAPI_1 = require("../api/embedAPI");
const emotion_2 = require("../controllers/emotion");
const app_1 = __importDefault(require("./app"));
exports.APIContext = React.createContext(null);
class Controller extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            emotion: null,
            id: `crate-${Math.random()
                .toString(36)
                .substr(2, 9)}`
        };
        this.registerEmotion = (styleInjection) => {
            this.setState({
                emotion: emotion_2.createEmotion(styleInjection)
            });
        };
    }
    shadowDOM(props) {
        const children = React.createElement("shadow-root", null, props.children);
        const supported = !!(document.head.createShadowRoot || document.head.attachShadow);
        return supported ? React.createElement(react_shadow_1.default.div, null, children) : children;
    }
    render() {
        const { id } = this.state;
        const { css, onAPI, interactive, open } = this.props;
        const styles = embedAPI_1.stylis(`.${id}`, css);
        return (React.createElement(this.shadowDOM, null,
            React.createElement("div", { className: emotion_1.cx(id, {
                    interactive,
                    open
                }) },
                React.createElement("shadow-styles", { ref: this.registerEmotion },
                    React.createElement("style", null, styles)),
                this.state.emotion && (React.createElement(emotion_2.Provider, { value: this.state.emotion },
                    React.createElement(exports.APIContext.Provider, { value: onAPI },
                        React.createElement(app_1.default, null)))))));
    }
}
exports.default = react_redux_1.connect(({ interactive, open, options }) => ({
    css: options.css,
    interactive,
    open
}))(Controller);
//# sourceMappingURL=index.js.map