"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const immer_1 = __importDefault(require("immer"));
const redux_actions_1 = require("redux-actions");
const constants_1 = require("./actions/constants");
const store = redux_actions_1.handleActions({
    [constants_1.TOGGLE]: (state, { payload }) => immer_1.default(state, draft => {
        const open = typeof payload === 'boolean' ? payload : !state.open;
        draft.open = open;
        // Load the embed if necessary
        if (open)
            draft.interactive = true;
        // Reset notifications + unread count
        draft.notifications = [];
        draft.unread = 0;
    }),
    [constants_1.TOGGLE_VISIBILITY]: (state, { payload }) => (Object.assign(Object.assign({}, state), { visible: payload })),
    [constants_1.UPDATE_OPTIONS]: (state, action) => (Object.assign(Object.assign({}, state), { options: Object.assign(Object.assign({}, state.options), action.payload) })),
    [constants_1.NOTIFICATION]: (state, action) => immer_1.default(state, draft => {
        draft.unread++;
        draft.notifications.push(Object.assign({ visible: true }, action.payload));
    }),
    [constants_1.REMOVE_NOTIFICATION]: (state, action) => immer_1.default(state, draft => {
        const index = draft.notifications.findIndex(message => message.id === action.payload.id);
        if (action.payload.decrement)
            draft.unread--;
        if (index !== -1) {
            draft.notifications.splice(index, 1);
        }
    }),
    [constants_1.UPDATE_UNREAD_COUNT]: (state, { payload }) => immer_1.default(state, draft => {
        draft.unread = payload;
    })
}, null);
exports.default = store;
//# sourceMappingURL=index.js.map