"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const observe = (value, store, callback) => {
    let observed = {};
    Object.keys(value).forEach(key => {
        store[key] = value[key];
        Object.defineProperty(observed, key, {
            get: () => store[key],
            set(value) {
                callback(key, value);
                store[key] = value;
            }
        });
    });
    observed.get = () => store;
    observed.set = value => {
        Object.keys(value).forEach(key => (store[key] = value[key]));
        return store;
    };
    return observed;
};
exports.default = observe;
//# sourceMappingURL=observe.js.map