"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.check = exports.expectValue = exports.is = exports.validate = void 0;
require("reflect-metadata");
const lodash_get_1 = __importDefault(require("lodash.get"));
const validators = __importStar(require("./validators"));
const validatedMetadataKey = Symbol('validated');
function validate(target, propertyName, descriptor) {
    let method = descriptor.value;
    descriptor.value = function () {
        let requiredParameters = Reflect.getOwnMetadata(validatedMetadataKey, target, propertyName);
        if (requiredParameters) {
            for (let [parameterIndex, validator] of requiredParameters) {
                validator(arguments[parameterIndex]);
            }
        }
        return method.apply(this, arguments);
    };
}
exports.validate = validate;
exports.is = Object.keys(validators).reduce((prev, validator) => (Object.assign(Object.assign({}, prev), { [validator]: (target, propertyKey, parameterIndex) => {
        let existingValidatedParameters = Reflect.getOwnMetadata(validatedMetadataKey, target, propertyKey) || [];
        existingValidatedParameters.push([parameterIndex, validators[validator]]);
        Reflect.defineMetadata(validatedMetadataKey, existingValidatedParameters, target, propertyKey);
    } })), {});
const expectValue = options => (path, type, isValid, acceptFalsy = true) => {
    const sliced = path.slice(1);
    const value = path === '' ? options : lodash_get_1.default(options, sliced);
    const valid = (typeof isValid === 'function' ? isValid(value) : typeof value === type) ||
        (!value && acceptFalsy);
    if (!valid) {
        console.error('Invalid options!', options);
        throw new TypeError(`Expected 'options${path}' to be typeof '${type}', received '${(value
            ? value.constructor.name
            : typeof value).toLowerCase()}'`);
    }
};
exports.expectValue = expectValue;
exports.check = validators;
//# sourceMappingURL=index.js.map